; 

  include \masm32\include\masm32rt.inc

  clearbuffer PROTO :DWORD
  WndProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD
  ColDialog   PROTO :DWORD,:DWORD,:DWORD,:DWORD

  .data?
      hButn1      dd ?
      hButn2      dd ?
      hButn3      dd ?
      hButn4      dd ?
      hButn5      dd ?
      hButn6      dd ?

      hEdit1      dd ?
      hEdit2      dd ?
      hEdit3      dd ?

      color       dd ?
      hInstance   dd ?
      hIconImage  dd ?
      hIcon       dd ?

    .data
      dlgname     db "COLORREF Color Picker",0

; 

    .code

start:
      mov hInstance, rv(GetModuleHandle, NULL)
      mov color, 00000000h                                  ; start the selected colour at BLACK
      
      ; -------------------------------------------
      ; Call the dialog box stored in resource file
      ; -------------------------------------------
      invoke DialogBoxParam,hInstance,100,0,ADDR WndProc,0

      invoke ExitProcess,eax

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

      LOCAL Ps :PAINTSTRUCT
      LOCAL buffer1[128]:BYTE
      LOCAL buffer2[128]:BYTE

      .if uMsg == WM_INITDIALOG
      
        szText dlgTitle," COLORREF Color Picker"
        invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle

        invoke LoadIcon,hInstance,10
        mov hIcon, eax

        invoke SendMessage,hWin,WM_SETICON,1,hIcon

        invoke GetDlgItem,hWin,104
        mov hEdit1, eax

        invoke GetDlgItem,hWin,105
        mov hEdit2, eax

        invoke GetDlgItem,hWin,106
        mov hEdit3, eax

        invoke GetDlgItem,hWin,101  ; save asm
        mov hButn1, eax

        invoke GetDlgItem,hWin,102  ; save basic
        mov hButn2, eax

        invoke GetDlgItem,hWin,103  ; save C/C++
        mov hButn3, eax

        invoke GetDlgItem,hWin,111  ; pick colour
        mov hButn4, eax

        invoke GetDlgItem,hWin,112  ; about
        mov hButn5, eax

        invoke GetDlgItem,hWin,113  ; exit
        mov hButn6, eax

        xor eax, eax
        ret

      .elseif uMsg == WM_COMMAND
        .if wParam == 111
          invoke ColDialog,hWin,hInstance,CC_FULLOPEN or CC_RGBINIT,color
          mov color, eax

          szText szh,"h"
          szText baz,"&H"
          szText cpp,"0x"

          invoke clearbuffer, ADDR buffer1
          invoke clearbuffer, ADDR buffer2

          invoke dw2hex, color, ADDR buffer2
          invoke szCatStr,ADDR buffer1,ADDR buffer2
          invoke szCatStr,ADDR buffer1,ADDR szh
          invoke SetWindowText,hEdit1,ADDR buffer1

          invoke clearbuffer, ADDR buffer1
          invoke szCatStr,ADDR buffer1,ADDR baz
          invoke szCatStr,ADDR buffer1,ADDR buffer2
          invoke SetWindowText,hEdit2,ADDR buffer1

          invoke clearbuffer, ADDR buffer1
          invoke szCatStr,ADDR buffer1,ADDR cpp
          invoke szCatStr,ADDR buffer1,ADDR buffer2
          invoke SetWindowText,hEdit3,ADDR buffer1

        .elseif wParam == 112
          szText AboutMsg,"COLORREF Color Picker",13,10,\
          "Copyright  MASM32 2000-2010"
          invoke ShellAbout,hWin,ADDR dlgTitle,ADDR AboutMsg,hIcon

        .elseif wParam == 113
          jmp Outa_Here

        .elseif wParam == 101
          invoke SendMessage,hEdit1,EM_SETSEL,0,-1
          invoke SendMessage,hEdit1,WM_COPY,0,0
          invoke SendMessage,hEdit1,EM_SETSEL,-1,0

        .elseif wParam == 102
          invoke SendMessage,hEdit2,EM_SETSEL,0,-1
          invoke SendMessage,hEdit2,WM_COPY,0,0
          invoke SendMessage,hEdit2,EM_SETSEL,-1,0

        .elseif wParam == 103
          invoke SendMessage,hEdit3,EM_SETSEL,0,-1
          invoke SendMessage,hEdit3,WM_COPY,0,0
          invoke SendMessage,hEdit3,EM_SETSEL,-1,0

        .endif

      .elseif uMsg == WM_CLOSE
        Outa_Here:
        invoke EndDialog,hWin,0

      .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
      ; ----------------------------------------
      ; The following function are in MASM32.LIB
      ; ----------------------------------------
        invoke FrameGrp,hButn4,hButn6,2,1,0
        invoke FrameGrp,hButn4,hButn6,4,1,1
        invoke FrameWindow,hWin,2,1,1
        invoke FrameWindow,hWin,4,1,0

        invoke EndPaint,hWin,ADDR Ps
        xor eax, eax
        ret

      .endif

    xor eax, eax
    ret

WndProc endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

clearbuffer proc lpbuffer:DWORD

    mov edx, [esp+4]
    push edi

    mov ecx, 32
    xor eax, eax
    mov edi, edx
    rep stosb

    pop edi

    ret 4

clearbuffer endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

ColDialog proc hWin:DWORD, instance:DWORD, Flags:DWORD, colr:DWORD

    LOCAL ccl:CHOOSECOLOR
    LOCAL crv[16]:DWORD

    lea edi, crv[0]
    mov ecx, 16
    mov eax, 0FFFFFFh
    rep stosd

    mov ccl.lStructSize,    sizeof CHOOSECOLOR
    m2m ccl.hwndOwner,      hWin
    m2m ccl.hInstance,      instance
    m2m ccl.rgbResult,      colr
    lea eax,                crv                ; address of 16 item DWORD array
    mov ccl.lpCustColors,   eax
    m2m ccl.Flags, Flags
    mov ccl.lCustData,      0
    mov ccl.lpfnHook,       0
    mov ccl.lpTemplateName, 0

    invoke ChooseColor,ADDR ccl

    .if eax != 0
      mov eax, ccl.rgbResult
    .endif

    ret

ColDialog endp

; 

end start
